searchNodes=[{"doc":"The default building blocks for working with HTML safely in Phoenix. This library provides three main functionalities: HTML safety Form handling (with CSRF protection) A tiny JavaScript library to enhance applications HTML safety One of the main responsibilities of this package is to provide convenience functions for escaping and marking HTML code as safe. By default, data output in templates is not considered safe: &lt; % = &quot;&lt;hello&gt;&quot; % &gt; will be shown as: &amp; lt ; hello &amp; gt ; User data or data coming from the database is almost never considered safe. However, in some cases, you may want to tag it as safe and show its &quot;raw&quot; contents: &lt; % = raw &quot;&lt;hello&gt;&quot; % &gt; Form handling See Phoenix.HTML.Form . JavaScript library This project ships with a tiny bit of JavaScript that listens to all click events to: Support data-confirm=&quot;message&quot; attributes, which shows a confirmation modal with the given message Support data-method=&quot;patch|post|put|delete&quot; attributes, which sends the current click as a PATCH/POST/PUT/DELETE HTTP request. You will need to add data-to with the URL and data-csrf with the CSRF token value Dispatch a &quot;phoenix.link.click&quot; event. You can listen to this event to customize the behaviour above. Returning false from this event will disable data-method . Stopping propagation will disable data-confirm To use the functionality above, you must load priv/static/phoenix_html.js into your build tool. Overriding the default confirmation behaviour You can override the default implementation by hooking into phoenix.link.click . Here is an example: window.addEventListener('phoenix.link.click', function (e) { // Introduce custom behaviour var message = e.target.getAttribute(&quot;data-prompt&quot;); var answer = e.target.getAttribute(&quot;data-prompt-answer&quot;); if(message &amp;&amp; answer &amp;&amp; (answer != window.prompt(message))) { e.preventDefault(); } }, false);","ref":"Phoenix.HTML.html","title":"Phoenix.HTML","type":"module"},{"doc":"Escapes an enumerable of attributes, returning iodata. The attributes are rendered in the given order. Note if a map is given, the key ordering is not guaranteed. The keys and values can be of any shape, as long as they implement the Phoenix.HTML.Safe protocol. In addition, if the key is an atom, it will be &quot;dasherized&quot;. In other words, :phx_value_id will be converted to phx-value-id . Furthermore, the following attributes provide behaviour: :aria , :data , and :phx - they accept a keyword list as value. data: [confirm: &quot;are you sure?&quot;] is converted to data-confirm=&quot;are you sure?&quot; . :class - it accepts a list of classes as argument. Each element in the list is separated by space. nil and false elements are discarded. class: [&quot;foo&quot;, nil, &quot;bar&quot;] then becomes class=&quot;foo bar&quot; . :id - it is validated raise if a number is given as ID, which is not allowed by the HTML spec and leads to unpredictable behaviour. Examples iex&gt; safe_to_string attributes_escape ( title : &quot;the title&quot; , id : &quot;the id&quot; , selected : true ) &quot; title= \\&quot; the title \\&quot; id= \\&quot; the id \\&quot; selected&quot; iex&gt; safe_to_string attributes_escape ( %{ data : [ confirm : &quot;Are you sure?&quot; ] , class : &quot;foo&quot; } ) &quot; class= \\&quot; foo \\&quot; data-confirm= \\&quot; Are you sure? \\&quot; &quot; iex&gt; safe_to_string attributes_escape ( %{ phx : [ value : [ foo : &quot;bar&quot; ] ] , class : &quot;foo&quot; } ) &quot; class= \\&quot; foo \\&quot; phx-value-foo= \\&quot; bar \\&quot; &quot;","ref":"Phoenix.HTML.html#attributes_escape/1","title":"Phoenix.HTML.attributes_escape/1","type":"function"},{"doc":"Escapes the HTML entities in the given term, returning safe iodata. iex&gt; html_escape ( &quot;&lt;hello&gt;&quot; ) { :safe , [ [ [ ] | &quot;&amp;lt;&quot; ] , &quot;hello&quot; | &quot;&amp;gt;&quot; ] } iex&gt; html_escape ( &#39;&lt;hello&gt;&#39; ) { :safe , [ &quot;&amp;lt;&quot; , 104 , 101 , 108 , 108 , 111 , &quot;&amp;gt;&quot; ] } iex&gt; html_escape ( 1 ) { :safe , &quot;1&quot; } iex&gt; html_escape ( { :safe , &quot;&lt;hello&gt;&quot; } ) { :safe , &quot;&lt;hello&gt;&quot; }","ref":"Phoenix.HTML.html#html_escape/1","title":"Phoenix.HTML.html_escape/1","type":"function"},{"doc":"Escapes HTML content to be inserted a JavaScript string. This function is useful in JavaScript responses when there is a need to escape HTML rendered from other templates, like in the following: $ ( &quot;#container&quot; ) . append ( &quot;&lt;%= javascript_escape(render(&quot; post . html &quot;, post: @post)) %&gt;&quot; ) ; It escapes quotes (double and single), double backslashes and others.","ref":"Phoenix.HTML.html#javascript_escape/1","title":"Phoenix.HTML.javascript_escape/1","type":"function"},{"doc":"Marks the given content as raw. This means any HTML code inside the given string won't be escaped. iex&gt; raw ( &quot;&lt;hello&gt;&quot; ) { :safe , &quot;&lt;hello&gt;&quot; } iex&gt; raw ( { :safe , &quot;&lt;hello&gt;&quot; } ) { :safe , &quot;&lt;hello&gt;&quot; } iex&gt; raw ( nil ) { :safe , &quot;&quot; }","ref":"Phoenix.HTML.html#raw/1","title":"Phoenix.HTML.raw/1","type":"function"},{"doc":"Converts a safe result into a string. Fails if the result is not safe. In such cases, you can invoke html_escape/1 or raw/1 accordingly before. You can combine html_escape/1 and safe_to_string/1 to convert a data structure to a escaped string: data |&gt; html_escape ( ) |&gt; safe_to_string ( )","ref":"Phoenix.HTML.html#safe_to_string/1","title":"Phoenix.HTML.safe_to_string/1","type":"function"},{"doc":"Guaranteed to be safe","ref":"Phoenix.HTML.html#t:safe/0","title":"Phoenix.HTML.safe/0","type":"type"},{"doc":"May be safe or unsafe (i.e. it needs to be converted)","ref":"Phoenix.HTML.html#t:unsafe/0","title":"Phoenix.HTML.unsafe/0","type":"type"},{"doc":"An EEx.Engine that guarantees templates are HTML Safe.","ref":"Phoenix.HTML.Engine.html","title":"Phoenix.HTML.Engine","type":"module"},{"doc":"Encodes the HTML templates to iodata.","ref":"Phoenix.HTML.Engine.html#encode_to_iodata!/1","title":"Phoenix.HTML.Engine.encode_to_iodata!/1","type":"function"},{"doc":"Define a Phoenix.HTML.Form struct and functions to interact with it. Access behaviour The Phoenix.HTML.Form struct implements the Access behaviour. When you do form[field] , it returns a Phoenix.HTML.FormField struct with the id , name , value , and errors prefilled. The field name can be either an atom or a string. If it is an atom, it assumes the form keeps both data and errors as atoms. If it is a string, it considers data and errors are stored as strings for said field.","ref":"Phoenix.HTML.Form.html","title":"Phoenix.HTML.Form","type":"module"},{"doc":"Defines the Phoenix.HTML.Form struct. Its fields are: :source - the data structure given to form_for/4 that implements the form data protocol :impl - the module with the form data protocol implementation. This is used to avoid multiple protocol dispatches. :id - the id to be used when generating input fields :index - the index of the struct in the form :name - the name to be used when generating input fields :data - the field used to store lookup data :params - the parameters associated to this form :hidden - a keyword list of fields that are required for submitting the form behind the scenes as hidden inputs :options - a copy of the options given when creating the form via form_for/4 without any form data specific key :errors - a keyword list of errors that associated with the form","ref":"Phoenix.HTML.Form.html#__struct__/0","title":"Phoenix.HTML.Form.__struct__/0","type":"function"},{"doc":"Generates a checkbox. This function is useful for sending boolean values to the server. Examples # Assuming form contains a User schema checkbox ( form , :famous ) #=&gt; &lt;input name=&quot;user[famous]&quot; type=&quot;hidden&quot; value=&quot;false&quot;&gt; #=&gt; &lt;input checked=&quot;checked&quot; id=&quot;user_famous&quot; name=&quot;user[famous]&quot; type=&quot;checkbox&quot; value=&quot;true&quot;&gt; Options :checked_value - the value to be sent when the checkbox is checked. Defaults to &quot;true&quot; :hidden_input - controls if this function will generate a hidden input to submit the unchecked value or not. Defaults to &quot;true&quot; :unchecked_value - the value to be sent when the checkbox is unchecked, Defaults to &quot;false&quot; :value - the value used to check if a checkbox is checked or unchecked. The default value is extracted from the form data if available All other options are forwarded to the underlying HTML tag. Hidden fields Because an unchecked checkbox is not sent to the server, Phoenix automatically generates a hidden field with the unchecked_value before the checkbox field to ensure the unchecked_value is sent when the checkbox is not marked. Set hidden_input to false If you don't want to send values from unchecked checkbox to the server.","ref":"Phoenix.HTML.Form.html#checkbox/3","title":"Phoenix.HTML.Form.checkbox/3","type":"function"},{"doc":"Generates a color input. See text_input/3 for example and docs.","ref":"Phoenix.HTML.Form.html#color_input/3","title":"Phoenix.HTML.Form.color_input/3","type":"function"},{"doc":"Generates a date input. See text_input/3 for example and docs.","ref":"Phoenix.HTML.Form.html#date_input/3","title":"Phoenix.HTML.Form.date_input/3","type":"function"},{"doc":"Generates select tags for date. Warning: this functionality is best provided by browsers nowadays. Consider using date_input/3 instead. Check datetime_select/3 for more information on options and supported values.","ref":"Phoenix.HTML.Form.html#date_select/3","title":"Phoenix.HTML.Form.date_select/3","type":"function"},{"doc":"Generates a datetime-local input. See text_input/3 for example and docs.","ref":"Phoenix.HTML.Form.html#datetime_local_input/3","title":"Phoenix.HTML.Form.datetime_local_input/3","type":"function"},{"doc":"Generates select tags for datetime. Warning: this functionality is best provided by browsers nowadays. Consider using datetime_local_input/3 instead. Examples # Assuming form contains a User schema datetime_select form , :born_at #=&gt; &lt;select id=&quot;user_born_at_year&quot; name=&quot;user[born_at][year]&quot;&gt;...&lt;/select&gt; / #=&gt; &lt;select id=&quot;user_born_at_month&quot; name=&quot;user[born_at][month]&quot;&gt;...&lt;/select&gt; / #=&gt; &lt;select id=&quot;user_born_at_day&quot; name=&quot;user[born_at][day]&quot;&gt;...&lt;/select&gt; — #=&gt; &lt;select id=&quot;user_born_at_hour&quot; name=&quot;user[born_at][hour]&quot;&gt;...&lt;/select&gt; : #=&gt; &lt;select id=&quot;user_born_at_min&quot; name=&quot;user[born_at][minute]&quot;&gt;...&lt;/select&gt; If you want to include the seconds field (hidden by default), pass second: [] : # Assuming form contains a User schema datetime_select form , :born_at , second : [ ] If you want to configure the years range: # Assuming form contains a User schema datetime_select form , :born_at , year : [ options : 1900 .. 2100 ] You are also able to configure :month , :day , :hour , :minute and :second . All options given to those keys will be forwarded to the underlying select. See select/4 for more information. For example, if you are using Phoenix with Gettext and you want to localize the list of months, you can pass :options to the :month key: # Assuming form contains a User schema datetime_select form , :born_at , month : [ options : [ { gettext ( &quot;January&quot; ) , &quot;1&quot; } , { gettext ( &quot;February&quot; ) , &quot;2&quot; } , { gettext ( &quot;March&quot; ) , &quot;3&quot; } , { gettext ( &quot;April&quot; ) , &quot;4&quot; } , { gettext ( &quot;May&quot; ) , &quot;5&quot; } , { gettext ( &quot;June&quot; ) , &quot;6&quot; } , { gettext ( &quot;July&quot; ) , &quot;7&quot; } , { gettext ( &quot;August&quot; ) , &quot;8&quot; } , { gettext ( &quot;September&quot; ) , &quot;9&quot; } , { gettext ( &quot;October&quot; ) , &quot;10&quot; } , { gettext ( &quot;November&quot; ) , &quot;11&quot; } , { gettext ( &quot;December&quot; ) , &quot;12&quot; } , ] ] You may even provide your own localized_datetime_select/3 built on top of datetime_select/3 : defp localized_datetime_select ( form , field , opts \\\\ [ ] ) do opts = Keyword . put ( opts , :month , options : [ { gettext ( &quot;January&quot; ) , &quot;1&quot; } , { gettext ( &quot;February&quot; ) , &quot;2&quot; } , { gettext ( &quot;March&quot; ) , &quot;3&quot; } , { gettext ( &quot;April&quot; ) , &quot;4&quot; } , { gettext ( &quot;May&quot; ) , &quot;5&quot; } , { gettext ( &quot;June&quot; ) , &quot;6&quot; } , { gettext ( &quot;July&quot; ) , &quot;7&quot; } , { gettext ( &quot;August&quot; ) , &quot;8&quot; } , { gettext ( &quot;September&quot; ) , &quot;9&quot; } , { gettext ( &quot;October&quot; ) , &quot;10&quot; } , { gettext ( &quot;November&quot; ) , &quot;11&quot; } , { gettext ( &quot;December&quot; ) , &quot;12&quot; } , ] ) datetime_select ( form , field , opts ) end Options :value - the value used to select a given option. The default value is extracted from the form data if available :default - the default value to use when none was given in :value and none is available in the form data :year , :month , :day , :hour , :minute , :second - options passed to the underlying select. See select/4 for more information. The available values can be given in :options . :builder - specify how the select can be build. It must be a function that receives a builder that should be invoked with the select name and a set of options. See builder below for more information. Builder The generated datetime_select can be customized at will by providing a builder option. Here is an example from EEx: &lt; % = datetime_select form , :born_at , builder : fn b -&gt; % &gt; Date : &lt; % = b . ( :day , [ ] ) % &gt; / &lt; % = b . ( :month , [ ] ) % &gt; / &lt; % = b . ( :year , [ ] ) % &gt; Time : &lt; % = b . ( :hour , [ ] ) % &gt; : &lt; % = b . ( :minute , [ ] ) % &gt; &lt; % end % &gt; Although we have passed empty lists as options (they are required), you could pass any option there and it would be given to the underlying select input. In practice, we recommend you to create your own helper with your default builder: def my_datetime_select ( form , field , opts \\\\ [ ] ) do builder = fn b -&gt; assigns = %{ b : b } ~H&quot;&quot;&quot; Date: &lt;%= @b.(:day, []) %&gt; / &lt;%= @b.(:month, []) %&gt; / &lt;%= @b.(:year, []) %&gt; Time: &lt;%= @b.(:hour, []) %&gt; : &lt;%= @b.(:minute, []) %&gt; &quot;&quot;&quot; end datetime_select ( form , field , [ builder : builder ] ++ opts ) end Then you are able to use your own datetime_select throughout your whole application. Supported date values The following values are supported as date: a map containing the year , month and day keys (either as strings or atoms) a tuple with three elements: {year, month, day} a string in ISO 8601 format nil Supported time values The following values are supported as time: a map containing the hour and minute keys and an optional second key (either as strings or atoms) a tuple with three elements: {hour, min, sec} a tuple with four elements: {hour, min, sec, usec} nil","ref":"Phoenix.HTML.Form.html#datetime_select/3","title":"Phoenix.HTML.Form.datetime_select/3","type":"function"},{"doc":"Generates an email input. See text_input/3 for example and docs.","ref":"Phoenix.HTML.Form.html#email_input/3","title":"Phoenix.HTML.Form.email_input/3","type":"function"},{"doc":"Generates a file input. It requires the given form to be configured with multipart: true when invoking form_for/4 , otherwise it fails with ArgumentError . See text_input/3 for example and docs.","ref":"Phoenix.HTML.Form.html#file_input/3","title":"Phoenix.HTML.Form.file_input/3","type":"function"},{"doc":"Generates a form tag with a form builder and an anonymous function. &lt; % = form_for @changeset , Routes . user_path ( @conn , :create ) , fn f -&gt; % &gt; Name : &lt; % = text_input f , :name % &gt; &lt; % end % &gt; Forms may be used in two distinct scenarios: with changeset data - when information to populate the form comes from a changeset. The changeset holds rich information, which helps provide conveniences with map data - a simple map of parameters (such as Plug.Conn.params can be given as data to the form) We will explore all them below. With changeset data The entry point for defining forms in Phoenix is with the form_for/4 function. For this example, we will use Ecto.Changeset , which integrates nicely with Phoenix forms via the phoenix_ecto package. Imagine you have the following action in your controller: def new ( conn , _params ) do changeset = User . changeset ( % User { } ) render conn , &quot;new.html&quot; , changeset : changeset end where User.changeset/2 is defined as follows: def changeset ( user , params \\ %{ } ) do Ecto.Changeset . cast ( user , params , [ :name , :age ] ) end Now a @changeset assign is available in views which we can pass to the form: &lt; % = form_for @changeset , Routes . user_path ( @conn , :create ) , fn f -&gt; % &gt; &lt; label &gt; Name : &lt; % = text_input f , :name % &gt; &lt; / label &gt; &lt; label &gt; Age : &lt; % = select f , :age , 18 .. 100 % &gt; &lt; / label &gt; &lt; % = submit &quot;Submit&quot; % &gt; &lt; % end % &gt; form_for/4 receives the Ecto.Changeset and converts it to a form, which is passed to the function as the argument f . All the remaining functions in this module receive the form and automatically generate the input fields, often by extracting information from the given changeset. For example, if the user had a default value for age set, it will automatically show up as selected in the form. A note on :errors Even if changeset.errors is non-empty, errors will not be displayed in a form if the changeset :action is nil or :ignore . This is useful for things like validation hints on form fields, e.g. an empty changeset for a new form. That changeset isn't valid, but we don't want to show errors until an actual user action has been performed. For example, if the user submits and a Repo.insert/1 is called and fails on changeset validation, the action will be set to :insert to show that an insert was attempted, and the presence of that action will cause errors to be displayed. The same is true for Repo.update/delete. If you want to show errors manually you can also set the action yourself, either directly on the Ecto.Changeset struct field or by using Ecto.Changeset.apply_action/2 . Since the action can be arbitrary, you can set it to :validate or anything else to avoid giving the impression that a database operation has actually been attempted. With map data form_for/4 expects as first argument any data structure that implements the Phoenix.HTML.FormData protocol. By default, Phoenix.HTML implements this protocol for Map . This is useful when you are creating forms that are not backed by any kind of data layer. Let's assume that we're submitting a form to the :new action in the FooController : &lt; % = form_for @conn . params , Routes . foo_path ( @conn , :new ) , fn f -&gt; % &gt; &lt; % = text_input f , :contents % &gt; &lt; % = submit &quot;Search&quot; % &gt; &lt; % end % &gt; Once the form is submitted, the form contents will be set directly as the parameters root, such as conn.params[&quot;contents&quot;] . If you prefer, you can pass the :as option to configure them to be nested: &lt; % = form_for @conn . params [ &quot;search&quot; ] || %{ } , Routes . foo_path ( @conn , :new ) , [ as : :search ] , fn f -&gt; % &gt; &lt; % = text_input f , :contents % &gt; &lt; % = submit &quot;Search&quot; % &gt; &lt; % end % &gt; In the example above, all form contents is now set inside conn.params[&quot;search&quot;] thanks to the [as: :search] option. Nested inputs If your data layer supports embedding or nested associations, you can use inputs_for to attach nested data to the form. Imagine the following Ecto schemas: defmodule User do use Ecto.Schema schema &quot;users&quot; do field :name embeds_one :permalink , Permalink end def changeset ( user \\ % User { } , params ) do user |&gt; Ecto.Changeset . cast ( params ) |&gt; Ecto.Changeset . cast_assoc ( :permalink ) end end defmodule Permalink do use Ecto.Schema embedded_schema do field :url end end In the form, you now can: &lt; % = form_for @changeset , Routes . user_path ( @conn , :create ) , fn f -&gt; % &gt; &lt; % = text_input f , :name % &gt; &lt; % = inputs_for f , :permalink , fn fp -&gt; % &gt; &lt; % = text_input fp , :url % &gt; &lt; % end % &gt; &lt; % end % &gt; The default option can be given to populate the fields if none is given: &lt; % = inputs_for f , :permalink , [ default : % Permalink { title : &quot;default&quot; } ] , fn fp -&gt; % &gt; &lt; % = text_input fp , :url % &gt; &lt; % end % &gt; inputs_for/4 can be used to work with single entities or collections. When working with collections, :prepend and :append can be used to add entries to the collection stored in the changeset. CSRF protection CSRF protection is a mechanism to ensure that the user who rendered the form is the one actually submitting it. This module generates a CSRF token by default. Your application should check this token on the server to avoid attackers from making requests on your server on behalf of other users. Phoenix by default checks this token. When posting a form with a host in its address, such as &quot;//host.com/path&quot; instead of only &quot;/path&quot;, Phoenix will include the host signature in the token and validate the token only if the accessed host is the same as the host in the token. This is to avoid tokens from leaking to third party applications. If this behaviour is problematic, you can generate a non-host specific token with Plug.CSRFProtection.get_csrf_token/0 and pass it to the form generator via the :csrf_token option. Options :as - the server side parameter in which all params for this form will be collected (i.e. as: :user_params would mean all fields for this form will be accessed as conn.params.user_params server side). Automatically inflected when a changeset is given. :method - the HTTP method. If the method is not &quot;get&quot; nor &quot;post&quot;, an input tag with name _method is generated along-side the form tag. Defaults to &quot;post&quot;. :multipart - when true, sets enctype to &quot;multipart/form-data&quot;. Required when uploading files :csrf_token - for &quot;post&quot; requests, the form tag will automatically include an input tag with name _csrf_token . When set to false, this is disabled :errors - use this to manually pass a keyword list of errors to the form (for example from conn.assigns[:errors] ). This option is only used when a connection is used as the form source and it will make the errors available under f.errors :id - the ID of the form attribute. If an ID is given, all form inputs will also be prefixed by the given ID All other options will be passed as html attributes, such as class: &quot;foo&quot; .","ref":"Phoenix.HTML.Form.html#form_for/4","title":"Phoenix.HTML.Form.form_for/4","type":"function"},{"doc":"Generates a hidden input. See text_input/3 for example and docs.","ref":"Phoenix.HTML.Form.html#hidden_input/3","title":"Phoenix.HTML.Form.hidden_input/3","type":"function"},{"doc":"Generates hidden inputs for the given form inputs. See inputs_for/2 and inputs_for/3 .","ref":"Phoenix.HTML.Form.html#hidden_inputs_for/1","title":"Phoenix.HTML.Form.hidden_inputs_for/1","type":"function"},{"doc":"Converts an attribute/form field into its humanize version. iex&gt; humanize ( :username ) &quot;Username&quot; iex&gt; humanize ( :created_at ) &quot;Created at&quot; iex&gt; humanize ( &quot;user_id&quot; ) &quot;User&quot;","ref":"Phoenix.HTML.Form.html#humanize/1","title":"Phoenix.HTML.Form.humanize/1","type":"function"},{"doc":"Receives two forms structs and checks if the given field changed. The field will have changed if either its associated value or errors changed. This is mostly used for optimization engines as an extension of the Access behaviour.","ref":"Phoenix.HTML.Form.html#input_changed?/3","title":"Phoenix.HTML.Form.input_changed?/3","type":"function"},{"doc":"Returns an id of a corresponding form field. The form should either be a Phoenix.HTML.Form emitted by form_for or an atom.","ref":"Phoenix.HTML.Form.html#input_id/2","title":"Phoenix.HTML.Form.input_id/2","type":"function"},{"doc":"Returns an id of a corresponding form field and value attached to it. Useful for radio buttons and inputs like multiselect checkboxes.","ref":"Phoenix.HTML.Form.html#input_id/3","title":"Phoenix.HTML.Form.input_id/3","type":"function"},{"doc":"Returns a name of a corresponding form field. The first argument should either be a Phoenix.HTML.Form or an atom. Examples iex&gt; Phoenix.HTML.Form . input_name ( :user , :first_name ) &quot;user[first_name]&quot;","ref":"Phoenix.HTML.Form.html#input_name/2","title":"Phoenix.HTML.Form.input_name/2","type":"function"},{"doc":"Gets the input type for a given field. If the underlying input type is a :text_field , a mapping could be given to further inflect the input type based solely on the field name. The default mapping is: %{ &quot;url&quot; =&gt; :url_input , &quot;email&quot; =&gt; :email_input , &quot;search&quot; =&gt; :search_input , &quot;password&quot; =&gt; :password_input }","ref":"Phoenix.HTML.Form.html#input_type/3","title":"Phoenix.HTML.Form.input_type/3","type":"function"},{"doc":"Returns the HTML validations that would apply to the given field.","ref":"Phoenix.HTML.Form.html#input_validations/2","title":"Phoenix.HTML.Form.input_validations/2","type":"function"},{"doc":"Returns a value of a corresponding form field. The form should either be a Phoenix.HTML.Form or an atom. The field is either a string or an atom. If the field is given as an atom, it will attempt to look data with atom keys. If a string, it will look data with string keys. When a form is given, it will lookup for changes and then fallback to parameters and finally fallback to the default struct/map value. Since the function looks up parameter values too, there is no guarantee that the value will have a certain type. For example, a boolean field will be sent as &quot;false&quot; as a parameter, and this function will return it as is. If you need to normalize the result of input_value , see normalize_value/2 .","ref":"Phoenix.HTML.Form.html#input_value/2","title":"Phoenix.HTML.Form.input_value/2","type":"function"},{"doc":"Same as inputs_for(form, field, []) .","ref":"Phoenix.HTML.Form.html#inputs_for/2","title":"Phoenix.HTML.Form.inputs_for/2","type":"function"},{"doc":"Generate a new form builder for the given parameter in form without an anonymous function. This functionality exists mostly for integration with Phoenix.LiveView that replaces the anonymous function for returning the generated forms instead. Keep in mind that this function does not generate hidden inputs automatically like inputs_for/4 . To generate them you need to explicit do it by yourself. &lt; . form for = { @changeset } action = { Routes . user_path ( @conn , :create ) } &gt; Name : &lt; % = text_input f , :name % &gt; &lt; % = for friend_form &lt;- inputs_for ( f , :friends ) do % &gt; &lt; % ! -- Generating hidden inputs -- ! % &gt; &lt; % = hidden_inputs_for ( friend_form ) % &gt; &lt; % = text_input friend_form , :name % &gt; &lt; % end % &gt; &lt; / . form &gt; See inputs_for/4 for the available options.","ref":"Phoenix.HTML.Form.html#inputs_for/3","title":"Phoenix.HTML.Form.inputs_for/3","type":"function"},{"doc":"Generate a new form builder for the given parameter in form. See the module documentation for examples of using this function. Options :id - the id to be used in the form, defaults to the concatenation of the given field to the parent form id :as - the name to be used in the form, defaults to the concatenation of the given field to the parent form name :default - the value to use if none is available :prepend - the values to prepend when rendering. This only applies if the field value is a list and no parameters were sent through the form. :append - the values to append when rendering. This only applies if the field value is a list and no parameters were sent through the form. :skip_hidden - skip the automatic rendering of hidden fields to allow for more tight control over the generated markup. You can access form.hidden to generate them manually within the supplied callback.","ref":"Phoenix.HTML.Form.html#inputs_for/4","title":"Phoenix.HTML.Form.inputs_for/4","type":"function"},{"doc":"Generates a label tag. Useful when wrapping another input inside a label. Examples label do radio_button :user , :choice , &quot;Choice&quot; end #=&gt; &lt;label&gt;...&lt;/label&gt; label class : &quot;control-label&quot; do radio_button :user , :choice , &quot;Choice&quot; end #=&gt; &lt;label class=&quot;control-label&quot;&gt;...&lt;/label&gt;","ref":"Phoenix.HTML.Form.html#label/1","title":"Phoenix.HTML.Form.label/1","type":"function"},{"doc":"Generates a label tag for the given field. The form should either be a Phoenix.HTML.Form emitted by form_for or an atom. All given options are forwarded to the underlying tag. A default value is provided for for attribute but can be overridden if you pass a value to the for option. Text content would be inferred from field if not specified as either a function argument or string value in a block. To wrap a label around an input, see label/1 . Examples # Assuming form contains a User schema label ( form , :name , &quot;Name&quot; ) #=&gt; &lt;label for=&quot;user_name&quot;&gt;Name&lt;/label&gt; label ( :user , :email , &quot;Email&quot; ) #=&gt; &lt;label for=&quot;user_email&quot;&gt;Email&lt;/label&gt; label ( :user , :email ) #=&gt; &lt;label for=&quot;user_email&quot;&gt;Email&lt;/label&gt; label ( :user , :email , class : &quot;control-label&quot; ) #=&gt; &lt;label for=&quot;user_email&quot; class=&quot;control-label&quot;&gt;Email&lt;/label&gt; label :user , :email do &quot;E-mail Address&quot; end #=&gt; &lt;label for=&quot;user_email&quot;&gt;E-mail Address&lt;/label&gt; label :user , :email , &quot;E-mail Address&quot; , class : &quot;control-label&quot; #=&gt; &lt;label class=&quot;control-label&quot; for=&quot;user_email&quot;&gt;E-mail Address&lt;/label&gt; label :user , :email , class : &quot;control-label&quot; do &quot;E-mail Address&quot; end #=&gt; &lt;label class=&quot;control-label&quot; for=&quot;user_email&quot;&gt;E-mail Address&lt;/label&gt;","ref":"Phoenix.HTML.Form.html#label/2","title":"Phoenix.HTML.Form.label/2","type":"function"},{"doc":"See label/2 .","ref":"Phoenix.HTML.Form.html#label/3","title":"Phoenix.HTML.Form.label/3","type":"function"},{"doc":"See label/2 .","ref":"Phoenix.HTML.Form.html#label/4","title":"Phoenix.HTML.Form.label/4","type":"function"},{"doc":"Generates a select tag with the given options . Values are expected to be an Enumerable containing two-item tuples (like maps and keyword lists) or any Enumerable where the element will be used both as key and value for the generated select. Examples # Assuming form contains a User schema multiple_select ( form , :roles , [ &quot;Admin&quot; : 1 , &quot;Power User&quot; : 2 ] ) #=&gt; &lt;select id=&quot;user_roles&quot; name=&quot;user[roles][]&quot;&gt; #=&gt; &lt;option value=&quot;1&quot;&gt;Admin&lt;/option&gt; #=&gt; &lt;option value=&quot;2&quot;&gt;Power User&lt;/option&gt; #=&gt; &lt;/select&gt; multiple_select ( form , :roles , [ &quot;Admin&quot; : 1 , &quot;Power User&quot; : 2 ] , selected : [ 1 ] ) #=&gt; &lt;select id=&quot;user_roles&quot; name=&quot;user[roles][]&quot;&gt; #=&gt; &lt;option value=&quot;1&quot; selected=&quot;selected&quot;&gt;Admin&lt;/option&gt; #=&gt; &lt;option value=&quot;2&quot;&gt;Power User&lt;/option&gt; #=&gt; &lt;/select&gt; When working with structs, associations and embeds, you will need to tell Phoenix how to extract the value out of the collection. For example, imagine user.roles is a list of %Role{} structs. You must call it as: multiple_select ( form , :roles , [ &quot;Admin&quot; : 1 , &quot;Power User&quot; : 2 ] , selected : Enum . map ( @user . roles , &amp; ( &amp;1 . id ) ) The :selected option will mark the given IDs as selected unless the form is being resubmitted. When resubmitted, it uses the form params as values. When used with Ecto, you will typically do a query to retrieve the IDs from the database: from r in Role , where : r . id in ^ ( params [ &quot;roles&quot; ] || [ ] ) And then use Ecto.Changeset.put_assoc/2 to insert the new roles into the user. Options :selected - the default options to be marked as selected. The values on this list are ignored in case ids have been set as parameters. All other options are forwarded to the underlying HTML tag.","ref":"Phoenix.HTML.Form.html#multiple_select/4","title":"Phoenix.HTML.Form.multiple_select/4","type":"function"},{"doc":"Normalizes an input value according to its input type . Certain HTML inputs values must be cast or have idiosyncracies when rendering them. The goal of this function is to encapsulate this logic. In particular: For &quot;datetime-local&quot; types, it converts DateTime and NaiveDateTime to strings without the second precision For &quot;checkboxes&quot; types, it returns a boolean depending if the input is &quot;true&quot; or not For &quot;textarea&quot;, it prefixes a newline to ensure newlines won't be ignored on submission. This requires however that the textarea is rendered with no spaces after its content","ref":"Phoenix.HTML.Form.html#normalize_value/2","title":"Phoenix.HTML.Form.normalize_value/2","type":"function"},{"doc":"Generates a number input. See text_input/3 for example and docs.","ref":"Phoenix.HTML.Form.html#number_input/3","title":"Phoenix.HTML.Form.number_input/3","type":"function"},{"doc":"Returns options to be used inside a select. This is useful when building the select by hand. It expects all options and one or more select values. Examples options_for_select ( [ &quot;Admin&quot; : &quot;admin&quot; , &quot;User&quot; : &quot;user&quot; ] , &quot;admin&quot; ) #=&gt; &lt;option value=&quot;admin&quot; selected=&quot;selected&quot;&gt;Admin&lt;/option&gt; #=&gt; &lt;option value=&quot;user&quot;&gt;User&lt;/option&gt; Groups are also supported: options_for_select ( [ &quot;Europe&quot; : [ &quot;UK&quot; , &quot;Sweden&quot; , &quot;France&quot; ] , ... ] , nil ) #=&gt; &lt;optgroup label=&quot;Europe&quot;&gt; #=&gt; &lt;option&gt;UK&lt;/option&gt; #=&gt; &lt;option&gt;Sweden&lt;/option&gt; #=&gt; &lt;option&gt;France&lt;/option&gt; #=&gt; &lt;/optgroup&gt;","ref":"Phoenix.HTML.Form.html#options_for_select/2","title":"Phoenix.HTML.Form.options_for_select/2","type":"function"},{"doc":"Generates a password input. For security reasons, the form data and parameter values are never re-used in password_input/3 . Pass the value explicitly if you would like to set one. See text_input/3 for example and docs.","ref":"Phoenix.HTML.Form.html#password_input/3","title":"Phoenix.HTML.Form.password_input/3","type":"function"},{"doc":"Generates a radio button. Invoke this function for each possible value you want to be sent to the server. Examples # Assuming form contains a User schema radio_button ( form , :role , &quot;admin&quot; ) #=&gt; &lt;input id=&quot;user_role_admin&quot; name=&quot;user[role]&quot; type=&quot;radio&quot; value=&quot;admin&quot;&gt; Options All options are simply forwarded to the underlying HTML tag.","ref":"Phoenix.HTML.Form.html#radio_button/4","title":"Phoenix.HTML.Form.radio_button/4","type":"function"},{"doc":"Generates a range input. See text_input/3 for example and docs.","ref":"Phoenix.HTML.Form.html#range_input/3","title":"Phoenix.HTML.Form.range_input/3","type":"function"},{"doc":"Generates a reset input to reset all the form fields to their original state. All options are forwarded to the underlying input tag. Examples reset &quot;Reset&quot; #=&gt; &lt;input type=&quot;reset&quot; value=&quot;Reset&quot;&gt; reset &quot;Reset&quot; , class : &quot;btn&quot; #=&gt; &lt;input type=&quot;reset&quot; value=&quot;Reset&quot; class=&quot;btn&quot;&gt;","ref":"Phoenix.HTML.Form.html#reset/2","title":"Phoenix.HTML.Form.reset/2","type":"function"},{"doc":"Generates a search input. See text_input/3 for example and docs.","ref":"Phoenix.HTML.Form.html#search_input/3","title":"Phoenix.HTML.Form.search_input/3","type":"function"},{"doc":"Generates a select tag with the given options . options are expected to be an enumerable which will be used to generate each respective option . The enumerable may have: keyword lists - each keyword list is expected to have the keys :key and :value . Additional keys such as :disabled may be given to customize the option two-item tuples - where the first element is an atom, string or integer to be used as the option label and the second element is an atom, string or integer to be used as the option value atom, string or integer - which will be used as both label and value for the generated select Optgroups If options is map or keyword list where the first element is a string, atom or integer and the second element is a list or a map, it is assumed the key will be wrapped in an &lt;optgroup&gt; and the value will be used to generate &lt;options&gt; nested under the group. Examples # Assuming form contains a User schema select ( form , :age , 0 .. 120 ) #=&gt; &lt;select id=&quot;user_age&quot; name=&quot;user[age]&quot;&gt; #=&gt; &lt;option value=&quot;0&quot;&gt;0&lt;/option&gt; #=&gt; ... #=&gt; &lt;option value=&quot;120&quot;&gt;120&lt;/option&gt; #=&gt; &lt;/select&gt; select ( form , :role , [ &quot;Admin&quot; : &quot;admin&quot; , &quot;User&quot; : &quot;user&quot; ] ) #=&gt; &lt;select id=&quot;user_role&quot; name=&quot;user[role]&quot;&gt; #=&gt; &lt;option value=&quot;admin&quot;&gt;Admin&lt;/option&gt; #=&gt; &lt;option value=&quot;user&quot;&gt;User&lt;/option&gt; #=&gt; &lt;/select&gt; select ( form , :role , [ [ key : &quot;Admin&quot; , value : &quot;admin&quot; , disabled : true ] , [ key : &quot;User&quot; , value : &quot;user&quot; ] ] ) #=&gt; &lt;select id=&quot;user_role&quot; name=&quot;user[role]&quot;&gt; #=&gt; &lt;option value=&quot;admin&quot; disabled=&quot;disabled&quot;&gt;Admin&lt;/option&gt; #=&gt; &lt;option value=&quot;user&quot;&gt;User&lt;/option&gt; #=&gt; &lt;/select&gt; You can also pass a prompt: select ( form , :role , [ &quot;Admin&quot; : &quot;admin&quot; , &quot;User&quot; : &quot;user&quot; ] , prompt : &quot;Choose your role&quot; ) #=&gt; &lt;select id=&quot;user_role&quot; name=&quot;user[role]&quot;&gt; #=&gt; &lt;option value=&quot;&quot;&gt;Choose your role&lt;/option&gt; #=&gt; &lt;option value=&quot;admin&quot;&gt;Admin&lt;/option&gt; #=&gt; &lt;option value=&quot;user&quot;&gt;User&lt;/option&gt; #=&gt; &lt;/select&gt; And customize the prompt as any other entry: select ( form , :role , [ &quot;Admin&quot; : &quot;admin&quot; , &quot;User&quot; : &quot;user&quot; ] , prompt : [ key : &quot;Choose your role&quot; , disabled : true ] ) #=&gt; &lt;select id=&quot;user_role&quot; name=&quot;user[role]&quot;&gt; #=&gt; &lt;option value=&quot;&quot; disabled=&quot;&quot;&gt;Choose your role&lt;/option&gt; #=&gt; &lt;option value=&quot;admin&quot;&gt;Admin&lt;/option&gt; #=&gt; &lt;option value=&quot;user&quot;&gt;User&lt;/option&gt; #=&gt; &lt;/select&gt; If you want to select an option that comes from the database, such as a manager for a given project, you may write: select ( form , :manager_id , Enum . map ( @managers , &amp; { &amp;1 . name , &amp;1 . id } ) ) #=&gt; &lt;select id=&quot;manager_id&quot; name=&quot;project[manager_id]&quot;&gt; #=&gt; &lt;option value=&quot;1&quot;&gt;Mary Jane&lt;/option&gt; #=&gt; &lt;option value=&quot;2&quot;&gt;John Doe&lt;/option&gt; #=&gt; &lt;/select&gt; Finally, if the values are a list or a map, we use the keys for grouping: select ( form , :country , [ &quot;Europe&quot; : [ &quot;UK&quot; , &quot;Sweden&quot; , &quot;France&quot; ] ] , ... ) #=&gt; &lt;select id=&quot;user_country&quot; name=&quot;user[country]&quot;&gt; #=&gt; &lt;optgroup label=&quot;Europe&quot;&gt; #=&gt; &lt;option&gt;UK&lt;/option&gt; #=&gt; &lt;option&gt;Sweden&lt;/option&gt; #=&gt; &lt;option&gt;France&lt;/option&gt; #=&gt; &lt;/optgroup&gt; #=&gt; ... #=&gt; &lt;/select&gt; Options :prompt - an option to include at the top of the options. It may be a string or a keyword list of attributes and the :key :selected - the default value to use when none was sent as parameter Be aware that a :multiple option will not generate a correctly functioning multiple select element. Use multiple_select/4 instead. All other options are forwarded to the underlying HTML tag.","ref":"Phoenix.HTML.Form.html#select/4","title":"Phoenix.HTML.Form.select/4","type":"function"},{"doc":"Generates a submit button to send the form. Examples submit do : &quot;Submit&quot; #=&gt; &lt;button type=&quot;submit&quot;&gt;Submit&lt;/button&gt;","ref":"Phoenix.HTML.Form.html#submit/1","title":"Phoenix.HTML.Form.submit/1","type":"function"},{"doc":"Generates a submit button to send the form. All options are forwarded to the underlying button tag. When called with a do: block, the button tag options come first. Examples submit &quot;Submit&quot; #=&gt; &lt;button type=&quot;submit&quot;&gt;Submit&lt;/button&gt; submit &quot;Submit&quot; , class : &quot;btn&quot; #=&gt; &lt;button class=&quot;btn&quot; type=&quot;submit&quot;&gt;Submit&lt;/button&gt; submit [ class : &quot;btn&quot; ] , do : &quot;Submit&quot; #=&gt; &lt;button class=&quot;btn&quot; type=&quot;submit&quot;&gt;Submit&lt;/button&gt;","ref":"Phoenix.HTML.Form.html#submit/2","title":"Phoenix.HTML.Form.submit/2","type":"function"},{"doc":"Generates a telephone input. See text_input/3 for example and docs.","ref":"Phoenix.HTML.Form.html#telephone_input/3","title":"Phoenix.HTML.Form.telephone_input/3","type":"function"},{"doc":"Generates a text input. The form should either be a Phoenix.HTML.Form emitted by form_for or an atom. All given options are forwarded to the underlying input, default values are provided for id, name and value if possible. Examples # Assuming form contains a User schema text_input ( form , :name ) #=&gt; &lt;input id=&quot;user_name&quot; name=&quot;user[name]&quot; type=&quot;text&quot; value=&quot;&quot;&gt; text_input ( :user , :name ) #=&gt; &lt;input id=&quot;user_name&quot; name=&quot;user[name]&quot; type=&quot;text&quot; value=&quot;&quot;&gt;","ref":"Phoenix.HTML.Form.html#text_input/3","title":"Phoenix.HTML.Form.text_input/3","type":"function"},{"doc":"Generates a textarea input. All given options are forwarded to the underlying input, default values are provided for id, name and textarea content if possible. Examples # Assuming form contains a User schema textarea ( form , :description ) #=&gt; &lt;textarea id=&quot;user_description&quot; name=&quot;user[description]&quot;&gt;&lt;/textarea&gt; New lines Notice the generated textarea includes a new line after the opening tag. This is because the HTML spec says new lines after tags must be ignored and all major browser implementations do that. So in order to avoid new lines provided by the user from being ignored when the form is resubmitted, we automatically add a new line before the text area value.","ref":"Phoenix.HTML.Form.html#textarea/3","title":"Phoenix.HTML.Form.textarea/3","type":"function"},{"doc":"Generates a time input. Options :precision - Allowed values: :minute , :second , :millisecond . Defaults to :minute . All other options are forwarded. See text_input/3 for example and docs. Examples time_input form , :time #=&gt; &lt;input id=&quot;form_time&quot; name=&quot;form[time]&quot; type=&quot;time&quot; value=&quot;23:00&quot;&gt; time_input form , :time , precision : :second #=&gt; &lt;input id=&quot;form_time&quot; name=&quot;form[time]&quot; type=&quot;time&quot; value=&quot;23:00:00&quot;&gt; time_input form , :time , precision : :millisecond #=&gt; &lt;input id=&quot;form_time&quot; name=&quot;form[time]&quot; type=&quot;time&quot; value=&quot;23:00:00.000&quot;&gt;","ref":"Phoenix.HTML.Form.html#time_input/3","title":"Phoenix.HTML.Form.time_input/3","type":"function"},{"doc":"Generates select tags for time. Warning: this functionality is best provided by browsers nowadays. Consider using time_input/3 instead. Check datetime_select/3 for more information on options and supported values.","ref":"Phoenix.HTML.Form.html#time_select/3","title":"Phoenix.HTML.Form.time_select/3","type":"function"},{"doc":"Generates an url input. See text_input/3 for example and docs.","ref":"Phoenix.HTML.Form.html#url_input/3","title":"Phoenix.HTML.Form.url_input/3","type":"function"},{"doc":"","ref":"Phoenix.HTML.Form.html#t:field/0","title":"Phoenix.HTML.Form.field/0","type":"type"},{"doc":"","ref":"Phoenix.HTML.Form.html#t:t/0","title":"Phoenix.HTML.Form.t/0","type":"type"},{"doc":"Converts a data structure into a Phoenix.HTML.Form struct.","ref":"Phoenix.HTML.FormData.html","title":"Phoenix.HTML.FormData","type":"protocol"},{"doc":"Receives the given field and returns its input type (:text_input, :select, etc). Returns nil if the type is unknown.","ref":"Phoenix.HTML.FormData.html#input_type/3","title":"Phoenix.HTML.FormData.input_type/3","type":"function"},{"doc":"Returns the HTML5 validations that would apply to the given field.","ref":"Phoenix.HTML.FormData.html#input_validations/3","title":"Phoenix.HTML.FormData.input_validations/3","type":"function"},{"doc":"Returns the value for the given field.","ref":"Phoenix.HTML.FormData.html#input_value/3","title":"Phoenix.HTML.FormData.input_value/3","type":"function"},{"doc":"Converts a data structure into a Phoenix.HTML.Form struct. The options are the same options given to form_for/4 . It can be used by implementations to configure their behaviour and it must be stored in the underlying struct, with any custom field removed.","ref":"Phoenix.HTML.FormData.html#to_form/2","title":"Phoenix.HTML.FormData.to_form/2","type":"function"},{"doc":"Converts the field in the given form based on the data structure into a list of Phoenix.HTML.Form structs. The options are the same options given to inputs_for/4 . It can be used by implementations to configure their behaviour and it must be stored in the underlying struct, with any custom field removed.","ref":"Phoenix.HTML.FormData.html#to_form/4","title":"Phoenix.HTML.FormData.to_form/4","type":"function"},{"doc":"","ref":"Phoenix.HTML.FormData.html#t:t/0","title":"Phoenix.HTML.FormData.t/0","type":"type"},{"doc":"The struct returned by form[field] . It has the following fields: :errors - a list of errors belonging to the field :field - the field name as an atom or a string :form - the parent form struct :id - the id to be used as form input as a string :name - the name to be used as form input as a string :value - the value for the input","ref":"Phoenix.HTML.FormField.html","title":"Phoenix.HTML.FormField","type":"module"},{"doc":"Conveniences for working with links and URLs in HTML.","ref":"Phoenix.HTML.Link.html","title":"Phoenix.HTML.Link","type":"module"},{"doc":"Generates a button tag that uses the Javascript function handleClick() (see phoenix_html.js) to submit the form data. Useful to ensure that links that change data are not triggered by search engines and other spidering software. Examples button ( &quot;hello&quot; , to : &quot;/world&quot; ) #=&gt; &lt;button class=&quot;button&quot; data-csrf=&quot;csrf_token&quot; data-method=&quot;post&quot; data-to=&quot;/world&quot;&gt;hello&lt;/button&gt; button ( &quot;hello&quot; , to : &quot;/world&quot; , method : :get , class : &quot;btn&quot; ) #=&gt; &lt;button class=&quot;btn&quot; data-method=&quot;get&quot; data-to=&quot;/world&quot;&gt;hello&lt;/button&gt; Options :to - the page to link to. This option is required :method - the method to use with the button. Defaults to :post. All other options are forwarded to the underlying button input. When the :method is set to :get and the :to URL contains query parameters the generated form element will strip the parameters in accordance with the W3C form specification. Data attributes Data attributes are added as a keyword list passed to the data key. The following data attributes are supported: data-confirm - shows a confirmation prompt before generating and submitting the form.","ref":"Phoenix.HTML.Link.html#button/2","title":"Phoenix.HTML.Link.button/2","type":"function"},{"doc":"Generates a link to the given URL. Examples link ( &quot;hello&quot; , to : &quot;/world&quot; ) #=&gt; &lt;a href=&quot;/world&quot;&gt;hello&lt;/a&gt; link ( &quot;hello&quot; , to : URI . parse ( &quot;https://elixir-lang.org&quot; ) ) #=&gt; &lt;a href=&quot;https://elixir-lang.org&quot;&gt;hello&lt;/a&gt; link ( &quot;&lt;hello&gt;&quot; , to : &quot;/world&quot; ) #=&gt; &lt;a href=&quot;/world&quot;&gt;&amp;lt;hello&amp;gt;&lt;/a&gt; link ( &quot;&lt;hello&gt;&quot; , to : &quot;/world&quot; , class : &quot;btn&quot; ) #=&gt; &lt;a class=&quot;btn&quot; href=&quot;/world&quot;&gt;&amp;lt;hello&amp;gt;&lt;/a&gt; link ( &quot;delete&quot; , to : &quot;/the_world&quot; , data : [ confirm : &quot;Really?&quot; ] ) #=&gt; &lt;a data-confirm=&quot;Really?&quot; href=&quot;/the_world&quot;&gt;delete&lt;/a&gt; # If you supply a method other than `:get`: link ( &quot;delete&quot; , to : &quot;/everything&quot; , method : :delete ) #=&gt; &lt;a href=&quot;/everything&quot; data-csrf=&quot;csrf_token&quot; data-method=&quot;delete&quot; data-to=&quot;/everything&quot;&gt;delete&lt;/a&gt; # You can use a `do ... end` block too: link to : &quot;/hello&quot; do &quot;world&quot; end #=&gt; &lt;a href=&quot;/hello&quot;&gt;world&lt;a&gt; Options :to - the page to link to. This option is required :method - the method to use with the link. In case the method is not :get , the link is generated inside the form which sets the proper information. In order to submit the form, JavaScript must be enabled :csrf_token - a custom token to use for links with a method other than :get . All other options are forwarded to the underlying &lt;a&gt; tag. Data attributes Data attributes are added as a keyword list passed to the data key. The following data attributes are supported: data-confirm - shows a confirmation prompt before generating and submitting the form when :method is not :get . CSRF Protection By default, CSRF tokens are generated through Plug.CSRFProtection .","ref":"Phoenix.HTML.Link.html#link/2","title":"Phoenix.HTML.Link.link/2","type":"function"},{"doc":"Defines the HTML safe protocol. In order to promote HTML safety, Phoenix templates do not use Kernel.to_string/1 to convert data types to strings in templates. Instead, Phoenix uses this protocol which must be implemented by data structures and guarantee that a HTML safe representation is returned. Furthermore, this protocol relies on iodata, which provides better performance when sending or streaming data to the client.","ref":"Phoenix.HTML.Safe.html","title":"Phoenix.HTML.Safe","type":"protocol"},{"doc":"","ref":"Phoenix.HTML.Safe.html#to_iodata/1","title":"Phoenix.HTML.Safe.to_iodata/1","type":"function"},{"doc":"","ref":"Phoenix.HTML.Safe.html#t:t/0","title":"Phoenix.HTML.Safe.t/0","type":"type"},{"doc":"Helpers related to producing HTML tags within templates. Note: with the addition of the HEEx template engine to Phoenix applications, the functions in this module have lost a bit of relevance and must only be used in special circumstances. Whenever possible, prefer to use the HEEx template engine instead of the functions here. For example, instead of: &lt; % = content_tag :div , class : @class do % &gt; Hello &lt; % end % &gt; Do: &lt; div class = { @class } &gt; Hello &lt; / div &gt; Note: the examples in this module use safe_to_string/1 imported from Phoenix.HTML for readability.","ref":"Phoenix.HTML.Tag.html","title":"Phoenix.HTML.Tag","type":"module"},{"doc":"Creates an HTML tag with given name, content, and attributes. See Phoenix.HTML.Tag.tag/2 for more information and examples. iex&gt; safe_to_string content_tag ( :p , &quot;Hello&quot; ) &quot;&lt;p&gt;Hello&lt;/p&gt;&quot; iex&gt; safe_to_string content_tag ( :p , &quot;&lt;Hello&gt;&quot; , class : &quot;test&quot; ) &quot;&lt;p class= \\&quot; test \\&quot; &gt;&amp;lt;Hello&amp;gt;&lt;/p&gt;&quot; iex&gt; safe_to_string ( content_tag :p , class : &quot;test&quot; do ...&gt; &quot;Hello&quot; ...&gt; end ) &quot;&lt;p class= \\&quot; test \\&quot; &gt;Hello&lt;/p&gt;&quot; iex&gt; safe_to_string content_tag ( :option , &quot;Display Value&quot; , [ { :data , [ foo : &quot;bar&quot; ] } , value : &quot;value&quot; ] ) &quot;&lt;option data-foo= \\&quot; bar \\&quot; value= \\&quot; value \\&quot; &gt;Display Value&lt;/option&gt;&quot;","ref":"Phoenix.HTML.Tag.html#content_tag/2","title":"Phoenix.HTML.Tag.content_tag/2","type":"function"},{"doc":"","ref":"Phoenix.HTML.Tag.html#content_tag/3","title":"Phoenix.HTML.Tag.content_tag/3","type":"function"},{"doc":"Generates a hidden input tag with a CSRF token. This could be used when writing a form without the use of tag helpers like form_tag/3 or form_for/4 , while maintaining CSRF protection. The to argument should be the same as the form action. Example &lt; form action = &quot;/login&quot; method = &quot;POST&quot; &gt; &lt; % = csrf_input_tag ( &quot;/login&quot; ) % &gt; etc . &lt; / form &gt; Additional options to the tag can be given.","ref":"Phoenix.HTML.Tag.html#csrf_input_tag/2","title":"Phoenix.HTML.Tag.csrf_input_tag/2","type":"function"},{"doc":"Generates a meta tag with CSRF information. Additional options to the tag can be given.","ref":"Phoenix.HTML.Tag.html#csrf_meta_tag/1","title":"Phoenix.HTML.Tag.csrf_meta_tag/1","type":"function"},{"doc":"Returns the csrf_token value to be used by forms, meta tags, etc. By default, CSRF tokens are generated through Plug.CSRFProtection which is capable of generating a separate token per host. Therefore it is recommended to pass the URI of the destination as argument. If none is given %URI{host: nil} is used, which implies a local request is being done.","ref":"Phoenix.HTML.Tag.html#csrf_token_value/1","title":"Phoenix.HTML.Tag.csrf_token_value/1","type":"function"},{"doc":"Generates a form tag. This function generates the &lt;form&gt; tag without its closing part. Check form_tag/3 for generating an enclosing tag. Examples form_tag ( &quot;/hello&quot; ) &lt; form action = &quot;/hello&quot; method = &quot;post&quot; &gt; form_tag ( &quot;/hello&quot; , method : :get ) &lt; form action = &quot;/hello&quot; method = &quot;get&quot; &gt; Options :method - the HTTP method. If the method is not &quot;get&quot; nor &quot;post&quot;, an input tag with name _method is generated along-side the form tag. Defaults to &quot;post&quot;. :multipart - when true, sets enctype to &quot;multipart/form-data&quot;. Required when uploading files :csrf_token - for &quot;post&quot; requests, the form tag will automatically include an input tag with name _csrf_token . When set to false, this is disabled All other options are passed to the underlying HTML tag. CSRF Protection By default, CSRF tokens are generated through Plug.CSRFProtection .","ref":"Phoenix.HTML.Tag.html#form_tag/2","title":"Phoenix.HTML.Tag.form_tag/2","type":"function"},{"doc":"Generates a form tag with the given contents. Examples form_tag ( &quot;/hello&quot; , method : &quot;get&quot; ) do &quot;Hello&quot; end &lt; form action = &quot;/hello&quot; method = &quot;get&quot; &gt; ... Hello ... &lt; / form &gt;","ref":"Phoenix.HTML.Tag.html#form_tag/3","title":"Phoenix.HTML.Tag.form_tag/3","type":"function"},{"doc":"Generates an img tag with a src. Examples img_tag ( user . photo_path ) &lt; img src = &quot;/photo.png&quot; &gt; img_tag ( user . photo , class : &quot;image&quot; ) &lt; img src = &quot;/smile.png&quot; class = &quot;image&quot; &gt; To generate a path to an image hosted in your application &quot;priv/static&quot;, with the @conn endpoint, use static_path/2 to get a URL with cache control parameters: img_tag ( Routes . static_path ( @conn , &quot;/logo.png&quot; ) ) &lt; img src = &quot;/logo-123456.png?vsn=d&quot; &gt; For responsive images, pass a map, list or string through :srcset . img_tag ( &quot;/logo.png&quot; , srcset : %{ &quot;/logo.png&quot; =&gt; &quot;1x&quot; , &quot;/logo-2x.png&quot; =&gt; &quot;2x&quot; } ) &lt; img src = &quot;/logo.png&quot; srcset = &quot;/logo.png 1x, /logo-2x.png 2x&quot; &gt; img_tag ( &quot;/logo.png&quot; , srcset : [ &quot;/logo.png&quot; , { &quot;/logo-2x.png&quot; , &quot;2x&quot; } ] ) &lt; img src = &quot;/logo.png&quot; srcset = &quot;/logo.png, /logo-2x.png 2x&quot; &gt;","ref":"Phoenix.HTML.Tag.html#img_tag/2","title":"Phoenix.HTML.Tag.img_tag/2","type":"function"},{"doc":"Creates an HTML tag with the given name and options. iex&gt; safe_to_string tag ( :br ) &quot;&lt;br&gt;&quot; iex&gt; safe_to_string tag ( :input , type : &quot;text&quot; , name : &quot;user_id&quot; ) &quot;&lt;input name= \\&quot; user_id \\&quot; type= \\&quot; text \\&quot; &gt;&quot; Data attributes In order to add custom data attributes you need to pass a tuple containing :data atom and a keyword list with data attributes' names and values as the first element in the tag's attributes keyword list: iex&gt; safe_to_string tag ( :input , [ data : [ foo : &quot;bar&quot; ] , id : &quot;some_id&quot; ] ) &quot;&lt;input data-foo= \\&quot; bar \\&quot; id= \\&quot; some_id \\&quot; &gt;&quot; Boolean values In case an attribute contains a boolean value, its key is repeated when it is true, as expected in HTML, or the attribute is completely removed if it is false: iex&gt; safe_to_string tag ( :audio , autoplay : &quot;autoplay&quot; ) &quot;&lt;audio autoplay= \\&quot; autoplay \\&quot; &gt;&quot; iex&gt; safe_to_string tag ( :audio , autoplay : true ) &quot;&lt;audio autoplay&gt;&quot; iex&gt; safe_to_string tag ( :audio , autoplay : false ) &quot;&lt;audio&gt;&quot; If you want the boolean attribute to be sent as is, you can explicitly convert it to a string before.","ref":"Phoenix.HTML.Tag.html#tag/1","title":"Phoenix.HTML.Tag.tag/1","type":"function"},{"doc":"","ref":"Phoenix.HTML.Tag.html#tag/2","title":"Phoenix.HTML.Tag.tag/2","type":"function"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Bug fix Set display to none on generated forms Warn for maps with atom keys","ref":"changelog.html#v3-3-1-2023-02-27","title":"Changelog - v3.3.1 (2023-02-27)","type":"extras"},{"doc":"Enhancements Support deeply nested class lists Implement Phoenix.HTML.Safe for URI Implement Phoenix.HTML.FormData for Map Bug fix Generate unique IDs for checkboxes based on the value Use artificial button click instead of form.submit in JavaScript to trigger all relevant events Fix a bug where nil/false/true attributes in aria / data / phx would emit empty or literal values, such as &quot;true&quot; and &quot;false&quot; . This release aligns them with all other attributes so both nil and false emit nothing. true emits the attribute with no value. Deprecations Phoenix.HTML.Tag.attributes_escape/1 is deprecated in favor of Phoenix.HTML.attributes_escape/1","ref":"changelog.html#v3-3-0-2023-02-10","title":"Changelog - v3.3.0 (2023-02-10)","type":"extras"},{"doc":"Enhancements Raise if the id attribute is set to a number. This is actually an invalid value according to the HTML spec and it can lead to problematic client behaviour, especially in LiveView and other client frameworks. Allow phx attributes to be nested, similar to aria and data attributes Allow hidden fields in forms to be a list of values","ref":"changelog.html#v3-2-0-2021-12-18","title":"Changelog - v3.2.0 (2021-12-18)","type":"extras"},{"doc":"Bug fix Do not submit data-method links if default has been prevented Deprecations Deprecate ~E and Phoenix.HTML.Tag.attributes_escape/1 Remove deprecated Phoenix.HTML.Link.link/1","ref":"changelog.html#v3-1-0-2021-10-23","title":"Changelog - v3.1.0 (2021-10-23)","type":"extras"},{"doc":"Bug fix Ensure class={@class} in HEEx templates and :class attribute in content_tag are properly escaped against XSS","ref":"changelog.html#v3-0-4-2021-09-23","title":"Changelog - v3.0.4 (2021-09-23)","type":"extras"},{"doc":"Bug fix Fix sorting of attributes in tag / content_tag","ref":"changelog.html#v3-0-3-2021-09-04","title":"Changelog - v3.0.3 (2021-09-04)","type":"extras"},{"doc":"Enhancements Support maps on Phoenix.HTML.Tag.attributes_escape/1","ref":"changelog.html#v3-0-2-2021-08-19","title":"Changelog - v3.0.2 (2021-08-19)","type":"extras"},{"doc":"Enhancements Add Phoenix.HTML.Tag.csrf_input_tag/2","ref":"changelog.html#v3-0-1-2021-08-14","title":"Changelog - v3.0.1 (2021-08-14)","type":"extras"},{"doc":"Enhancements Allow extra html attributes on the :prompt option in select Make Plug an optional dependency Prefix form id on inputs when it is given to form_for/3 Allow %URI{} to be passed to link/2 and button/2 as :to Expose Phoenix.HTML.Tag.csrf_token_value/1 Add Phoenix.HTML.Tag.attributes_escape/1 Bug fixes Honor the form attribute when creating hidden checkbox input Use to_iso8601 as the standard implementation for safe dates and times Deprecations form_for without an anonymous function has been deprecated. v3.0 has deprecated the usage, v3.1 will emit warnings, and v3.2 will fully remove the functionality Backwards incompatible changes Strings given as attributes keys in tag and content_tag are now emitted as is (without being dasherized) and are also HTML escaped Prefix form id on inputs when it is given to form_for/3 By default dates and times will format to the to_iso8601 functions provided by their implementation Do not include csrf-param and method-param in generated csrf_meta_tag Remove deprecated escape_javascript in favor of javascript_escape Remove deprecated field_value in favor of input_value Remove deprecated field_name in favor of input_name Remove deprecated field_id in favor of input_id","ref":"changelog.html#v3-0-0-2021-08-06","title":"Changelog - v3.0.0 (2021-08-06)","type":"extras"},{"doc":"Bug fixes Fix warnings on Elixir v1.12","ref":"changelog.html#v2-14-3-2020-12-12","title":"Changelog - v2.14.3 (2020-12-12)","type":"extras"},{"doc":"Deprecations Deprecate Phoenix -specific assigns :view_module and :view_template","ref":"changelog.html#v2-14-2-2020-04-30","title":"Changelog - v2.14.2 (2020-04-30)","type":"extras"},{"doc":"Enhancements Add Phoenix.HTML.Form.options_for_select/2 Add Phoenix.HTML.Form.inputs_for/3 Bug fixes Disable hidden input for disabled checkboxes","ref":"changelog.html#v2-14-1-2020-03-20","title":"Changelog - v2.14.1 (2020-03-20)","type":"extras"},{"doc":"Enhancements Remove enforce_utf8 workaround on forms as it is no longer required by browser Remove support tuple-based date/time with microseconds calendar types Allow strings as first element in content_tag Add :srcset support to img_tag Allow inputs_for to skip hidden fields","ref":"changelog.html#v2-14-0-2020-01-28","title":"Changelog - v2.14.0 (2020-01-28)","type":"extras"},{"doc":"Bug fixes Fix invalid :line in Elixir v1.10.0","ref":"changelog.html#v2-13-4-2020-01-28","title":"Changelog - v2.13.4 (2020-01-28)","type":"extras"},{"doc":"Enhancements Add atom support to FormData Bug fixes Keep proper line numbers on .eex templates for proper coverage","ref":"changelog.html#v2-13-3-2019-05-31","title":"Changelog - v2.13.3 (2019-05-31)","type":"extras"},{"doc":"Bug fixes Stop event propagation when confirm dialog is canceled","ref":"changelog.html#v2-13-2-2019-03-29","title":"Changelog - v2.13.2 (2019-03-29)","type":"extras"},{"doc":"Enhancements Allow safe content to be given to label Also escale template literals in javascript_escape/1 Bug fixes Fix deprecation warnings to point to the correct alternative","ref":"changelog.html#v2-13-1-2019-01-05","title":"Changelog - v2.13.1 (2019-01-05)","type":"extras"},{"doc":"Enhancements Require Elixir v1.5+ for more efficient template compilation/rendering Add Phoenix.HTML.Engine.encode_to_iodata!/1 Add Phoenix.HTML.Form.form_for/3 that works without an anonymous function Deprecations Deprecate Phoenix.HTML.escape_javascript/1 in favor of Phoenix.HTML.javascript_escape/1 for consistency","ref":"changelog.html#v2-13-0-2018-12-09","title":"Changelog - v2.13.0 (2018-12-09)","type":"extras"},{"doc":"Enhancements Configurable and extendable data-confirm behaviour Allow data-confirm with submit buttons Support ISO 8601 formatted strings for date and time values Bug fixes Provide a default id of the field name for @conn based forms","ref":"changelog.html#v2-12-0-2018-08-06","title":"Changelog - v2.12.0 (2018-08-06)","type":"extras"},{"doc":"Enhancements Support custom precision on time input Bug fixes Do not raise when : is part of a path on link/button attributes","ref":"changelog.html#v2-11-2-2018-04-13","title":"Changelog - v2.11.2 (2018-04-13)","type":"extras"},{"doc":"Enhancements Add label/1 Copy the target attribute of the link in the generated JS form Bug fixes Support any value that is html escapable in radio_button","ref":"changelog.html#v2-11-1-2018-03-20","title":"Changelog - v2.11.1 (2018-03-20)","type":"extras"},{"doc":"Enhancements Add date, datetime-local and time input types Enable string keys to be usable with forms Support carriage return in text_to_html Add support for HTML5 boolean attributes to content_tag and tag Improve performance by relying on html_safe_to_iodata/1 Protect against CSRF tokens leaking across hosts when the POST URL is dynamic Require to attribute in links and buttons to explicitly pass protocols as a separate option for safety reasons Bug fixes Guarantee input_name/2 always returns strings Improve handling of uncommon whitespace and null in escape_javascript Escape value attribute so it is never treated as a boolean Backwards incompatible changes The :csrf_token_generator configuration in the Phoenix.HTML app no longer works due to the improved security mechanisms","ref":"changelog.html#v2-11-0-2018-03-09","title":"Changelog - v2.11.0 (2018-03-09)","type":"extras"},{"doc":"Enhancements Do not require the :as option in form_for","ref":"changelog.html#v2-10-5-2017-11-08","title":"Changelog - v2.10.5 (2017-11-08)","type":"extras"},{"doc":"Bug fixes Fix formatting of days in datetime_builder","ref":"changelog.html#v2-10-4-2017-08-15","title":"Changelog - v2.10.4 (2017-08-15)","type":"extras"},{"doc":"Enhancements Allow specifying a custom CSRF token generator Bug fixes Do not submit method: :get in buttons as &quot;post&quot;","ref":"changelog.html#v2-10-3-2017-07-30","title":"Changelog - v2.10.3 (2017-07-30)","type":"extras"},{"doc":"Bug fixes Traverse DOM elements up when handling data-method","ref":"changelog.html#v2-10-2-2017-07-24","title":"Changelog - v2.10.2 (2017-07-24)","type":"extras"},{"doc":"Bug fixes Only generate CSRF token if necessary","ref":"changelog.html#v2-10-1-2017-07-22","title":"Changelog - v2.10.1 (2017-07-22)","type":"extras"},{"doc":"Enhancements Support custom attributes in options in select Bug fixes Accept non-binary values in textarea's content Allow nested forms on the javascript side. This means link and button no longer generate a child form such as the :form option has no effect and &quot;data-submit=parent&quot; is no longer supported. Instead &quot;data-to&quot; and &quot;data-method&quot; are set on the entities and the form is generated on the javascript side of things","ref":"changelog.html#v2-10-0-2017-07-21","title":"Changelog - v2.10.0 (2017-07-21)","type":"extras"},{"doc":"Bug fixes Once again support any name for atom forms","ref":"changelog.html#v2-9-3-2016-12-24","title":"Changelog - v2.9.3 (2016-12-24)","type":"extras"},{"doc":"Bug fixes Always read from form.params and then from :selected in select and multiple_select before falling back to input_value/2","ref":"changelog.html#v2-9-2-2016-12-24","title":"Changelog - v2.9.2 (2016-12-24)","type":"extras"},{"doc":"Bug fixes Implement proper input_value/3 callback","ref":"changelog.html#v2-9-1-2016-12-20","title":"Changelog - v2.9.1 (2016-12-20)","type":"extras"},{"doc":"Enhancements Add img_tag/2 helper to Phoenix.HTML.Tag Submit nearest form even if not direct descendent Use more iodata for tag/2 and content_tag/3 Add input_value/3 , input_id/2 and input_name/2 as a unified API around the input (alongside input_type/3 and input_validations/2 )","ref":"changelog.html#v2-9-0-2016-12-19","title":"Changelog - v2.9.0 (2016-12-19)","type":"extras"},{"doc":"Enhancements Add csrf_meta_tag/0 helper to Phoenix.HTML.Tag Allow passing a do: option to Phoenix.HTML.Link.button/2","ref":"changelog.html#v2-8-0-2016-11-15","title":"Changelog - v2.8.0 (2016-11-15)","type":"extras"},{"doc":"Enhancements Render button tags for form submits and in the button/2 function Allow submit/2 and button/2 to receive do blocks Support the :multiple option in file_input/3 Remove previously deprecated and unused model field","ref":"changelog.html#v2-7-0-2016-09-21","title":"Changelog - v2.7.0 (2016-09-21)","type":"extras"},{"doc":"Enhancements Remove warnings on v1.4 Bug fixes Ensure some contents are properly escaped as an integer Ensure JavaScript data-submit events bubble up until it finds the proper parent","ref":"changelog.html#v2-6-1-2016-07-08","title":"Changelog - v2.6.1 (2016-07-08)","type":"extras"},{"doc":"Enhancements Raise helpful error when using invalid iodata Inline date/time API with Elixir v1.3 Calendar types Add :insert_brs option to text_to_html/2 Run on Erlang 19 without warnings Client-side changes Use event delegation in phoenix_html.js Drop IE8 support on phoenix_html.js Backwards incompatible changes :min , :sec option in Phoenix.HTML.Form ( datetime_select/3 and time_select/3 ) are no longer supported. Use :minute or :second instead.","ref":"changelog.html#v2-6-0-2016-06-16","title":"Changelog - v2.6.0 (2016-06-16)","type":"extras"},{"doc":"Bug fixes Ensure multipart files work with inputs_for","ref":"changelog.html#v2-5-1-2016-03-12","title":"Changelog - v2.5.1 (2016-03-12)","type":"extras"},{"doc":"Enhancements Introduce form.data field instead of form.model . Currently those values are kept in sync then the form is built but form.model will be deprecated in the long term","ref":"changelog.html#v2-5-0-2016-01-28","title":"Changelog - v2.5.0 (2016-01-28)","type":"extras"},{"doc":"Enhancements Add rel=nofollow auto generation for non-get links Introduce :selected option for select and multiple_select Bug fixes Fix safe engine incorrectly marking safe code as unsafe when last expression is &lt;% ... %&gt;","ref":"changelog.html#v2-4-0-2016-01-21","title":"Changelog - v2.4.0 (2016-01-21)","type":"extras"},{"doc":"Enhancements Add escape_javascript/1 Add helpful error message when using unknown @inner assign Add Phoenix.HTML.Format.text_to_html/2","ref":"changelog.html#v2-3-0-2015-12-16","title":"Changelog - v2.3.0 (2015-12-16)","type":"extras"},{"doc":"Bug fix Allow the :name to be given in forms. For this, using :name to configure the underlying input name prefix has been deprecated in favor of :as","ref":"changelog.html#v2-2-0-2015-09-01","title":"Changelog - v2.2.0 (2015-09-01)","type":"extras"},{"doc":"Bug fix Do not include values in password_input/3","ref":"changelog.html#v2-1-2-2015-08-22","title":"Changelog - v2.1.2 (2015-08-22)","type":"extras"},{"doc":"Enhancements Allow nil in raw/1 Allow block options in label/3 Introduce :skip_deleted in inputs_for/4","ref":"changelog.html#v2-1-1-2015-08-15","title":"Changelog - v2.1.1 (2015-08-15)","type":"extras"},{"doc":"Enhancements Add an index field to forms to be used by inputs_for/4 collections","ref":"changelog.html#v2-1-0-2015-08-06","title":"Changelog - v2.1.0 (2015-08-06)","type":"extras"},{"doc":"Bug fix Include web directory in Hex package","ref":"changelog.html#v2-0-1-2015-07-31","title":"Changelog - v2.0.1 (2015-07-31)","type":"extras"},{"doc":"Enhancements No longer generate onclick attributes. The main motivation for this is to provide support for Content Security Policy, which recommends disabling all inline scripts in a page. We took the opportunity to also add support for data-confirm in link/2 .","ref":"changelog.html#v2-0-0-2015-07-30","title":"Changelog - v2.0.0 (2015-07-30)","type":"extras"},{"doc":"Enhancements Support input_type/2 and input_validations/2 as reflection mechanisms","ref":"changelog.html#v1-4-0-2015-07-26","title":"Changelog - v1.4.0 (2015-07-26)","type":"extras"},{"doc":"Enhancements Add Phoenix.HTML.Form.inputs_for/4 support Add multiple select support Add reset input Infer default text context for labels","ref":"changelog.html#v1-3-0-2015-07-23","title":"Changelog - v1.3.0 (2015-07-23)","type":"extras"},{"doc":"Bug fix Ensure nil parameters are not discarded when rendering input","ref":"changelog.html#v1-2-1-2015-06-02","title":"Changelog - v1.2.1 (2015-06-02)","type":"extras"},{"doc":"Enhancements Add label/3 for generating a label tag within a form","ref":"changelog.html#v1-2-0-2015-05-30","title":"Changelog - v1.2.0 (2015-05-30)","type":"extras"},{"doc":"Enhancements Allow do/end syntax with link/2 Raise on missing assigns","ref":"changelog.html#v1-1-0-2015-05-20","title":"Changelog - v1.1.0 (2015-05-20)","type":"extras"},{"doc":"Bug fixes Avoid variable clash in Phoenix.HTML engine buffers","ref":"changelog.html#v1-0-1","title":"Changelog - v1.0.1","type":"extras"},{"doc":"Enhancements Provides an EEx engine with HTML safe rendering Provides a Phoenix.HTML.Safe protocol Provides a Phoenix.HTML.FormData protocol Provides functions for generating tags, links and form builders in a safe way","ref":"changelog.html#v1-0-0","title":"Changelog - v1.0.0","type":"extras"}]